package gssim.schedframe.scheduling.plugin.grid;


import gridsim.gssim.SubmittedTask;
import gridsim.gssim.policy.InExecuionList;
import gssim.schedframe.scheduling.ExecTaskInterface;
import gssim.schedframe.scheduling.Executable;
import gssim.schedframe.scheduling.queues.TaskQueue;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import schedframe.scheduling.AbstractProcesses;
import schedframe.scheduling.Job;
import schedframe.scheduling.Task;
import schedframe.scheduling.TaskInterface;
import test.rewolucja.scheduling.implementation.LocalManagementSystem;
import test.rewolucja.scheduling.plan.AllocationInterfaceNew;


/**
 * 
 * @author Marcin Krystek
 *
 */
public class GssimJobRegistry extends AbstractJobRegistry {
	
	private static final long serialVersionUID = 8030555906990767342L;

	private static Log log = LogFactory.getLog(GssimJobRegistry.class);
	

	
	private String context;

	public GssimJobRegistry(){
		log.warn("Methods from JobRegistry interface are not implemented.");
	}
	

	/*public ExecutablesList createExecutables(Task task, ArrayList<AllocationInterfaceNew> allocations) {

		ExecutablesList executables  = new ExecutablesList();
		
		for (int i = 0; i < allocations.size(); i++) {

			AllocationInterfaceNew<?> allocation = allocations.get(i);

			String refersTo = allocation.getProcessGroupId(); // null;//allocation.getRefersTo();
			if(refersTo == null)
				refersTo = task.getId();
			
			Executable exec = null;

			if(refersTo.equals(task.getId())){
				exec = new Executable(task);
			} else {
				List<AbstractProcesses> processes = task.getProcesses();
				if(processes == null) {
					try {
						log.error("Allocation: " + allocation.getDocument() + "\nrefers to unknown task or processes set." +
								" Set correct value (task id or prcesses set id) for allocation refersTo attribute.");
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
				boolean found = false;
				for(int j = 0; j < processes.size() && !found; j++){
					AbstractProcesses procesesSet = processes.get(j);
					if(refersTo.equals(procesesSet.getId())){
						exec = new Executable(task, procesesSet);
						found = true;
					}
				}
				if(!found){
					log.error("Allocation refers to unknown proceses set.");
				}
				
			}
		
			exec.setUserID(task.getSenderId());
			exec.setLength(task.getLength());
			exec.setReservationId(allocation.getReservationId());
			executables.add(exec);
			
			HostInterface<?> host = allocation.getHost();
			ComputingResourceTypeInterface<?> crt = host.getMachineParameters();
			if(crt != null){
				ComputingResourceTypeItemInterface<?> crti = crt.getComputingResourceTypeItem(0);
				if(crti != null){
					ParameterPropertyInterface<?> properties[] = crti.getHostParameter().getProperty();
					for(int p = 0; p < properties.length; p++){
						ParameterPropertyInterface<?> property = properties[p];
						if("chosenCPUs".equals(property.getName())){
							Object cpuNames = property.getValue();
							exec.addSpecificResource(ResourceParameterName.FREECPUS, cpuNames);
						}
					}
				}
			}
		}
		return executables;
	}*/
	

	public Executable createExecutable(Task task, AllocationInterfaceNew allocation) {

		String refersTo = allocation.getProcessGroupId(); // null;//allocation.getRefersTo();
		if(refersTo == null)
			refersTo = task.getId();
			
		Executable exec = null;

		if(refersTo.equals(task.getId())){
			exec = new Executable(task);
		} else {
			List<AbstractProcesses> processes = task.getProcesses();
			if(processes == null) {
				try {
					log.error("Allocation: " + allocation.getDocument() + "\nrefers to unknown task or processes set." +
							" Set correct value (task id or prcesses set id) for allocation refersTo attribute.");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			boolean found = false;
			for(int j = 0; j < processes.size() && !found; j++){
				AbstractProcesses procesesSet = processes.get(j);
				if(refersTo.equals(procesesSet.getId())){
					exec = new Executable(task, procesesSet);
					found = true;
				}
			}
			if(!found){
				log.error("Allocation refers to unknown proceses set.");
			}
				
		}
		
		exec.setUserID(task.getSenderId());
		exec.setLength(task.getLength());
		exec.setReservationId(allocation.getReservationId());
			
		/*HostInterface<?> host = allocation.getHost();
		ComputingResourceTypeInterface<?> crt = host.getMachineParameters();
		if(crt != null){
			ComputingResourceTypeItemInterface<?> crti = crt.getComputingResourceTypeItem(0);
			if(crti != null){
				ParameterPropertyInterface<?> properties[] = crti.getHostParameter().getProperty();
				for(int p = 0; p < properties.length; p++){
					ParameterPropertyInterface<?> property = properties[p];
					if("chosenCPUs".equals(property.getName())){
						Object cpuNames = property.getValue();
						exec.addSpecificResource(ResourceParameterName.FREECPUS, cpuNames);
					}
				}
			}
		}*/
		return exec;
	}
	

	public List<? extends TaskInterface<?>> prepareTaskQueue(List<?> jobsList, String jobRegistryString){
		
		List<TaskInterface<?>> tasks = new ArrayList<TaskInterface<?>>();
		TaskQueue waitingTasks = new TaskQueue();
		
		for(int i = 0; i < jobsList.size(); i++){
			Job newJob = (Job)jobsList.get(i);
			addJob(newJob);
			waitingTasks.addAll(newJob.getTask());
		}
		
		if(jobRegistryString != null){
			waitingTasks.addAll(get(jobRegistryString).getTask());
		}
		tasks.addAll(waitingTasks.getReadyTasks(this));
		return tasks;
		
		
	}

}
